<?php
/**
 * @version		$Id$
 * @package		Google Tracking
 * @subpackage	Module
 * @author		Michal Unzeitig, ARTIO s.r.o.
 * @copyright	Copyright (C) 2010 ARTIO s.r.o., All rights reserved.
 * @license		GNU/GPL
 */
// security check
defined('_JEXEC') or die('Restricted access');

class plgSystemGACode extends JPlugin
{
    
    private $uaScript =     
"  <script type=\"text/javascript\">  
     var _gaq = _gaq || [];
    _gaq.push(['_setAccount', '%s']);
    _gaq.push(['_trackPageview']);

    (function() {
      var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
      ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
      var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
    })();
  </script>
";
    
    private $uaScriptOld = 
"  <script type=\"text/javascript\">
    var gaJsHost = ((\"https:\" == document.location.protocol ) ? \"https://ssl.\" : \"http://www.\");
    document.write(unescape(\"%3Cscript src='\" + gaJsHost + \"google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E\"));
  </script>
";
    
    
    private $totals;
    private $shopper;
    private $autoincrement;
    private $orderItems;
    private $purchase;
    private $vendor;
    private $run;

    function plgSystemGACode (&$subject)
    {
        parent::__construct($subject);

        // load plugin parameters
        $this->_plugin = & JPluginHelper::getPlugin('system', 'gacode');
        $this->_params = new JParameter($this->_plugin->params);
    }

    function __destruct ()
    {
        if (!$this->run) return;
                
        print($this->getCode());
        @ob_flush();
    }

    function onAfterRender ()
    {
        // do not run in admin
        $mainframe = JFactory::getApplication();
        $this->run = !$mainframe->isAdmin();
        
        // this needs to be here as the JRequest vars are not available in contructor 
        // Do not show GA-code if: 
        // tmpl=component is used (AJAX component's will broke sometimes if GA-code is added to reply)
        if (
	       JRequest::getVar('tmpl') == 'component'
    	   // view is xml or pdf or feed
            || JRequest::getVar('view') == 'xml' 
            || JRequest::getVar('view') == 'pdf'
            || JRequest::getVar('format') == 'feed'
        )
		    $this->run = false;
        
        $this->purchase = (JRequest::getVar('option') == 'com_virtuemart' 
            && (JRequest::getVar('page') == 'checkout.index'  
                && JRequest::getVar('checkout_last_step') == 3));        
        
        if (!$this->run) return;
        
        // append code to body
        JResponse::setBody(str_replace("</body>", $this->getCode() . "\r\n</body>", JResponse::getBody()));
        
        $this->run = false;
    }

    function getCode()
    {
        // load needed ORDER information
        if ($this->purchase) $this->loadOrderData();
        $vmTracking = ($this->purchase && $this->_params->get('trackEcommerce', 1)) ? $this->getVMTrackCode() : '';
        $cTrack = $this->purchase && $this->_params->get('trackConversions', 1);
        // = sprintf($this->_params->get('uaScript', $this->uaScript),  $this->_params->get('uaCode', ''), $vmTracking);
      
        $code = '';
        
        // place to add conversion tracking code
        if ($cTrack) {
            $code .= "<div id=\"awtracking\"></div>\n";
        }        
        
        if (!$this->purchase) {
            // standard tracking code
            $uaScript = $this->_params->get('uaScript', $this->uaScript);
            if (strlen(trim($uaScript)) == 0) $uaScript = $this->uaScript;
            
            $code .= sprintf($uaScript, $this->_params->get('uaCode', ''));
        }        
        //if ($this->purchase) {
        // test with old code
        else {
            $code .= $this->uaScriptOld;
            
            // generate GA tracking    
            $code .= "<script type=\"text/javascript\">\n";            
            
            $code .= "  try {\n";
            $code .= "  function GATrack() {\n";
            //$code .= $vmTracking . "\n";
            
            $code .= sprintf("    var pageTracker = _gat._getTracker(\"%s\");\n", $this->_params->get('uaCode', ''));
            $code .= "    pageTracker._trackPageview();\n";
            $code .= $vmTracking = ($this->purchase && $this->_params->get('trackEcommerce', 1)) ? $this->getVMTrackCodeOld() : '';
            //$code .= "    alert('click!'); return false;\n";
                        
            //$code .= $this->_params->get('uaScriptOld', $this->uaScriptOld), $track); 
            
            // if conversion tracking
            if ($cTrack) {
                $code .= "    document.getElementById('awtracking').innerHTML = GATrackCode;\n";
            }
            //$code .= "    alert('clicked!'); return false;\n";
            $code .= "  }\n";
            
            // generate conversion tracking
            if ($cTrack) {
                $cCode = $this->_params->get('conversionCode', '');
                $cCode = str_replace(array("\r\n", "\n", "script"), array(" ", " ", "scr' + ' ipt"), $cCode);
                $code .= "  var GATrackCode = '" . str_replace('%s', $this->totals['order_total'], $cCode) . "';\n";            
            }
            // map code generation to button click
            $code .= "  document.adminForm.formSubmit.addEventListener('click', GATrack, true);\n";
            $code .= "  } catch(err) {}\n";
            $code .= "</script>\n";
        }

        return $code;
    }

    function loadOrderData()
    {
        $chkout = new vm_ps_checkout();
        $this->totals = $chkout->calc_order_totals($_REQUEST);
        
        $db = &JFactory::getDBO();
        
        $q = 'SELECT city, state, country FROM #__vm_user_info'
          . ' WHERE user_info_id = \'' . $_REQUEST['ship_to_info_id'] . '\';';
        $db->setQuery($q);
        $this->shopper = $db->loadObject();
        
        $q = "SHOW TABLE STATUS LIKE '" . $db->replacePrefix('#__vm_orders') . "'";
        $db->setQuery($q);
        $this->autoincrement = $db->loadObject();
        
        $q = "SELECT * FROM #__vm_vendor WHERE vendor_id = 1"; 
        $db->setQuery($q);
        $this->vendor = $db->loadObject();
    }
    
    function getProductInfo($id, $desc)
    {
        $db = &JFactory::getDBO();
        
        $q = "SELECT p.product_id, p.product_sku, p.product_name,  GROUP_CONCAT(c.category_name SEPARATOR ', ') AS categories"
            . " FROM #__vm_product AS p"
            . " LEFT JOIN #__vm_product_category_xref AS pc ON (p.product_id = pc.product_id)" 
            . " LEFT JOIN #__vm_category AS c ON (pc.category_id = c.category_id)" 		    
		    . " WHERE p.product_id = $id";
		$db->setQuery($q);
		$item = $db->loadObject();
		
		$ps_product = new ps_product;
		$product_price_arr = $ps_product->get_adjusted_attribute_price($id, $desc);
        $item->product_price = $GLOBALS['CURRENCY']->convert($product_price_arr['product_price'], $product_price_arr['product_currency']);
		
		return $item;
    }
    
    function getVMTrackCode ()
    {        
        $code = sprintf("    _gaq.push(['_addTrans', '%d', '%s', '%f', '%s', '%f', '%s', '%s', '%s']);\n", 
                $this->autoincrement->Auto_increment,
                $this->vendor->vendor_store_name,
                $this->totals['order_total'],
                $this->totals['order_tax'], 
                $this->totals['order_shipping'],
                $this->shopper->city,
                $this->shopper->state,
                $this->shopper->country
                );
        
        $cart = $_SESSION['cart'];
        for ($i = 0; $i < $cart['idx']; $i++) {
            $item = $this->getProductInfo($cart[$i]['product_id'], $cart[$i]['description']); 
            $code .= sprintf("    _gaq.push(['_addItem', '%d', '%s', '%s', '%s', '%f', '%f']);\n", 
                     $this->autoincrement->Auto_increment, 
                     $item->product_sku,
                     $item->product_name,
                     $item->categories, 
                     $item->product_price,
                     $cart[$i]['quantity']
                     );
        }
                
        $code .= "    _gaq.push(['_trackTrans']);\n";
        return $code;
    }
    
    function getVMTrackCodeOld ()
    {        
        $code = sprintf("    pageTracker._addTrans('%d', '%s', '%f', '%s', '%f', '%s', '%s', '%s');\n", 
                $this->autoincrement->Auto_increment,
                $this->vendor->vendor_store_name,
                $this->totals['order_total'],
                $this->totals['order_tax'], 
                $this->totals['order_shipping'],
                $this->shopper->city,
                $this->shopper->state,
                $this->shopper->country
                );
        
        $cart = $_SESSION['cart'];
        for ($i = 0; $i < $cart['idx']; $i++) {
            $item = $this->getProductInfo($cart[$i]['product_id'], $cart[$i]['description']); 
            $code .= sprintf("    pageTracker._addItem('%d', '%s', '%s', '%s', '%f', '%f');\n", 
                     $this->autoincrement->Auto_increment, 
                     $item->product_sku,
                     $item->product_name,
                     $item->categories, 
                     $item->product_price,
                     $cart[$i]['quantity']
                     );
        }
                
        $code .= "    pageTracker._trackTrans();\n";
        return $code;
    }    

}
?>